
/*
 * $Id: constants.i,v 1.1.1.1 2001/10/15 06:54:54 davidma Exp $
 *
 * Python libnet
 * Copyright (C) 2001, David Margrave (davidma@eskimo.com)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

const unsigned int IPPROTO_IP=IPPROTO_IP;
const unsigned int IPPROTO_TCP=IPPROTO_TCP;
const unsigned int IPPROTO_UDP=IPPROTO_UDP;
const unsigned int IPPROTO_ICMP=IPPROTO_ICMP;
const unsigned int IPPROTO_IGMP=IPPROTO_IGMP;
const unsigned int IPPROTO_OSPF=IPPROTO_OSPF;
const unsigned int IPPROTO_OSPF_LSA=IPPROTO_OSPF_LSA;
const unsigned int IPPROTO_VRRP=IPPROTO_VRRP;
const unsigned int IPPROTO_RAW=IPPROTO_RAW;

const unsigned int ARP_H=LIBNET_ARP_H;
const unsigned int DNS_H=LIBNET_DNS_H;
const unsigned int ETH_H=LIBNET_ETH_H;
const unsigned int ICMP_H=LIBNET_ICMP_H;
const unsigned int ICMP_ECHO_H=LIBNET_ICMP_ECHO_H;
const unsigned int ICMP_MASK_H=LIBNET_ICMP_MASK_H;
const unsigned int ICMP_UNREACH_H=LIBNET_ICMP_UNREACH_H;
const unsigned int ICMP_TIMXCEED_H=LIBNET_ICMP_TIMXCEED_H;
const unsigned int ICMP_REDIRECT_H=LIBNET_ICMP_REDIRECT_H;
const unsigned int ICMP_TS_H=LIBNET_ICMP_TS_H;
const unsigned int IGMP_H=LIBNET_IGMP_H;
const unsigned int IP_H=LIBNET_IP_H;
const unsigned int RIP_H=LIBNET_RIP_H;
const unsigned int TCP_H=LIBNET_TCP_H;
const unsigned int UDP_H=LIBNET_UDP_H;
const unsigned int VRRP_H=LIBNET_VRRP_H;

const unsigned int IP_MAXPACKET=IP_MAXPACKET;
const unsigned int MAX_IPOPTLEN=MAX_IPOPTLEN;
const unsigned int IP_OFFMASK=IP_OFFMASK;
const unsigned int IP_DF=IP_DF;
const unsigned int IP_MF=IP_MF;

const unsigned int TH_URG=TH_URG;
const unsigned int TH_ACK=TH_ACK;
const unsigned int TH_PUSH=TH_PUSH;
const unsigned int TH_RST=TH_RST;
const unsigned int TH_SYN=TH_SYN;
const unsigned int TH_FIN=TH_FIN;

const unsigned int ICMP_ECHOREPLY=ICMP_ECHOREPLY;
const unsigned int ICMP_UNREACH=ICMP_UNREACH;
const unsigned int ICMP_SOURCEQUENCH=ICMP_SOURCEQUENCH;
const unsigned int ICMP_REDIRECT=ICMP_REDIRECT;
const unsigned int ICMP_ECHO=ICMP_ECHO;
const unsigned int ICMP_ROUTERADVERT=ICMP_ROUTERADVERT;
const unsigned int ICMP_ROUTERSOLICIT=ICMP_ROUTERSOLICIT;
const unsigned int ICMP_TIMXCEED=ICMP_TIMXCEED;
const unsigned int ICMP_PARAMPROB=ICMP_PARAMPROB;
const unsigned int ICMP_TSTAMP=ICMP_TSTAMP;
const unsigned int ICMP_TSTAMPREPLY=ICMP_TSTAMPREPLY;
const unsigned int ICMP_IREQ=ICMP_IREQ;
const unsigned int ICMP_IREQREPLY=ICMP_IREQREPLY;
const unsigned int ICMP_MASKREQ=ICMP_MASKREQ;
const unsigned int ICMP_MASKREPLY=ICMP_MASKREPLY;
const unsigned int ICMP_UNREACH_NET=ICMP_UNREACH_NET;
const unsigned int ICMP_UNREACH_HOST=ICMP_UNREACH_HOST;
const unsigned int ICMP_UNREACH_PROTOCOL=ICMP_UNREACH_PROTOCOL;
const unsigned int ICMP_UNREACH_PORT=ICMP_UNREACH_PORT;
const unsigned int ICMP_UNREACH_NEEDFRAG=ICMP_UNREACH_NEEDFRAG;
const unsigned int ICMP_UNREACH_SRCFAIL=ICMP_UNREACH_SRCFAIL;
const unsigned int ICMP_UNREACH_NET_UNKNOWN=ICMP_UNREACH_NET_UNKNOWN;
const unsigned int ICMP_UNREACH_HOST_UNKNOWN=ICMP_UNREACH_HOST_UNKNOWN;
const unsigned int ICMP_UNREACH_ISOLATED=ICMP_UNREACH_ISOLATED;
const unsigned int ICMP_UNREACH_NET_PROHIB=ICMP_UNREACH_NET_PROHIB;
const unsigned int ICMP_UNREACH_HOST_PROHIB=ICMP_UNREACH_HOST_PROHIB;
const unsigned int ICMP_UNREACH_TOSNET=ICMP_UNREACH_TOSNET;
const unsigned int ICMP_UNREACH_TOSHOST=ICMP_UNREACH_TOSHOST;
const unsigned int ICMP_UNREACH_FILTER_PROHIB=ICMP_UNREACH_FILTER_PROHIB;
const unsigned int ICMP_UNREACH_HOST_PRECEDENCE=ICMP_UNREACH_HOST_PRECEDENCE;
const unsigned int ICMP_UNREACH_PRECEDENCE_CUTOFF=ICMP_UNREACH_PRECEDENCE_CUTOFF;
const unsigned int ICMP_REDIRECT_NET=ICMP_REDIRECT_NET;
const unsigned int ICMP_REDIRECT_HOST=ICMP_REDIRECT_HOST;
const unsigned int ICMP_REDIRECT_TOSNET=ICMP_REDIRECT_TOSNET;
const unsigned int ICMP_REDIRECT_TOSHOST=ICMP_REDIRECT_TOSHOST;
const unsigned int ICMP_TIMXCEED_INTRANS=ICMP_TIMXCEED_INTRANS;
const unsigned int ICMP_TIMXCEED_REASS=ICMP_TIMXCEED_REASS;
const unsigned int ICMP_PARAMPROB_OPTABSENT=ICMP_PARAMPROB_OPTABSENT;

const unsigned int IGMP_MEMBERSHIP_QUERY=IGMP_MEMBERSHIP_QUERY;
const unsigned int IGMP_V1_MEMBERSHIP_REPORT=IGMP_V1_MEMBERSHIP_REPORT;
const unsigned int IGMP_V2_MEMBERSHIP_REPORT=IGMP_V2_MEMBERSHIP_REPORT;
const unsigned int IGMP_LEAVE_GROUP=IGMP_LEAVE_GROUP;

const unsigned int ARPHRD_ETHER=ARPHRD_ETHER;
const unsigned int ARPOP_REQUEST=ARPOP_REQUEST;
const unsigned int ARPOP_REPLY=ARPOP_REPLY;
const unsigned int ARPOP_REVREQUEST=ARPOP_REVREQUEST;
const unsigned int ARPOP_REVREPLY=ARPOP_REVREPLY;
const unsigned int ARPOP_INVREQUEST=ARPOP_INVREQUEST;
const unsigned int ARPOP_INVREPLY=ARPOP_INVREPLY;

const unsigned int RIPCMD_REQUEST=RIPCMD_REQUEST;
const unsigned int RIPCMD_RESPONSE=RIPCMD_RESPONSE;
const unsigned int RIPCMD_TRACEON=RIPCMD_TRACEON;
const unsigned int RIPCMD_TRACEOFF=RIPCMD_TRACEOFF;
const unsigned int RIPCMD_POLL=RIPCMD_POLL;
const unsigned int RIPCMD_POLLENTRY=RIPCMD_POLLENTRY;
const unsigned int RIPCMD_MAX=RIPCMD_MAX;
const unsigned int RIPVER_0=RIPVER_0;
const unsigned int RIPVER_1=RIPVER_1;
const unsigned int RIPVER_2=RIPVER_2;

const unsigned int OSPF_H=LIBNET_OSPF_H;
const unsigned int HELLO_H=LIBNET_HELLO_H;
const unsigned int DBD_H=LIBNET_DBD_H;
const unsigned int LSR_H=LIBNET_LSR_H;
const unsigned int LSU_H=LIBNET_LSU_H;
const unsigned int LSA_H=LIBNET_LSA_H;
const unsigned int AUTH_H=LIBNET_AUTH_H;
const unsigned int OSPF_CKSUM=LIBNET_OSPF_CKSUM;
const unsigned int LS_RTR_LEN=LIBNET_LS_RTR_LEN;
const unsigned int LS_NET_LEN=LIBNET_LS_NET_LEN;
const unsigned int LS_SUM_LEN=LIBNET_LS_SUM_LEN;
const unsigned int LS_AS_EXT_LEN=LIBNET_LS_AS_EXT_LEN;
const unsigned int OSPF_UMD=LIBNET_OSPF_UMD;
const unsigned int OSPF_HELLO=LIBNET_OSPF_HELLO;
const unsigned int OSPF_DBD=LIBNET_OSPF_DBD;
const unsigned int OSPF_LSR=LIBNET_OSPF_LSR;
const unsigned int OSPF_LSU=LIBNET_OSPF_LSU;
const unsigned int OSPF_LSA=LIBNET_OSPF_LSA;
const unsigned int OSPF_AUTH_NULL=LIBNET_OSPF_AUTH_NULL;
const unsigned int OSPF_AUTH_SIMPLE=LIBNET_OSPF_AUTH_SIMPLE;
const unsigned int OSPF_AUTH_MD5=LIBNET_OSPF_AUTH_MD5;
const unsigned int OPT_EBIT=LIBNET_OPT_EBIT;
const unsigned int OPT_MCBIT=LIBNET_OPT_MCBIT;
const unsigned int OPT_NPBIT=LIBNET_OPT_NPBIT;
const unsigned int OPT_EABIT=LIBNET_OPT_EABIT;
const unsigned int OPT_DCBIT=LIBNET_OPT_DCBIT;
const unsigned int DBD_IBIT=LIBNET_DBD_IBIT;
const unsigned int DBD_MBIT=LIBNET_DBD_MBIT;
const unsigned int DBD_MSBIT=LIBNET_DBD_MSBIT;
const unsigned int LS_TYPE_RTR=LIBNET_LS_TYPE_RTR;
const unsigned int LS_TYPE_NET=LIBNET_LS_TYPE_NET;
const unsigned int LS_TYPE_IP=LIBNET_LS_TYPE_IP;
const unsigned int LS_TYPE_ASBR=LIBNET_LS_TYPE_ASBR;
const unsigned int LS_TYPE_ASEXT=LIBNET_LS_TYPE_ASEXT;
const unsigned int RTR_FLAGS_W=LIBNET_RTR_FLAGS_W;
const unsigned int RTR_FLAGS_E=LIBNET_RTR_FLAGS_E;
const unsigned int RTR_FLAGS_B=LIBNET_RTR_FLAGS_B;
const unsigned int LINK_ID_NBR_ID=LIBNET_LINK_ID_NBR_ID;
const unsigned int LINK_ID_IP_DES=LIBNET_LINK_ID_IP_DES;
const unsigned int LINK_ID_SUB=LIBNET_LINK_ID_SUB;
const unsigned int RTR_TYPE_PTP=LIBNET_RTR_TYPE_PTP;
const unsigned int RTR_TYPE_TRANS=LIBNET_RTR_TYPE_TRANS;
const unsigned int RTR_TYPE_STUB=LIBNET_RTR_TYPE_STUB;
const unsigned int AS_E_BIT_ON=LIBNET_AS_E_BIT_ON;

const unsigned int VRRP_TYPE_ADVERT=LIBNET_VRRP_TYPE_ADVERT;
const unsigned int VRRP_AUTH_NONE=LIBNET_VRRP_AUTH_NONE;
const unsigned int VRRP_AUTH_PASSWD=LIBNET_VRRP_AUTH_PASSWD;
const unsigned int VRRP_AUTH_IPAH=LIBNET_VRRP_AUTH_IPAH;

const unsigned int PRAND_MAX=LIBNET_PRAND_MAX;
const unsigned int PR2=LIBNET_PR2;
const unsigned int PR8=LIBNET_PR8;
const unsigned int PR16=LIBNET_PR16;
const unsigned int PRu16=LIBNET_PRu16;
const unsigned int PR32=LIBNET_PR32;
const unsigned int PRu32=LIBNET_PRu32;

const unsigned int ERR_WARNING=LIBNET_ERR_WARNING;
const unsigned int ERR_CRITICAL=LIBNET_ERR_CRITICAL;
const unsigned int ERR_FATAL=LIBNET_ERR_FATAL;

const unsigned int DONT_RESOLVE=LIBNET_DONT_RESOLVE;
const unsigned int RESOLVE=LIBNET_RESOLVE;

const unsigned int ETHER_ADDR_LEN=ETHER_ADDR_LEN;
const unsigned int ETHERTYPE_PUP=ETHERTYPE_PUP;
const unsigned int ETHERTYPE_IP=ETHERTYPE_IP;
const unsigned int ETHERTYPE_ARP=ETHERTYPE_ARP;
const unsigned int ETHERTYPE_REVARP=ETHERTYPE_REVARP;
const unsigned int ETHERTYPE_VLAN=ETHERTYPE_VLAN;
const unsigned int ETHERTYPE_LOOPBACK=ETHERTYPE_LOOPBACK;

